/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using MeshVR;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using Battlehub.RTCommon;namespace PluginIdea{    public class MeshDecal : MVRScript, IGL    {        public struct BlendMode        {            public const int Zero = 0;            public const int One = 1;            public const int DstColor = 2;            public const int SrcColor = 3;            public const int OneMinusDstColor = 4;            public const int SrcAlpha = 5;            public const int OneMinusSrcColor = 6;            public const int DstAlpha = 7;            public const int OneMinusDstAlpha = 8;            public const int SrcAlphaSaturate = 9;            public const int OneMinusSrcAlpha = 10;        }        private List<string> blendModes = new List<string> { "Opaque", "AlphaBlend", "Multiply", "DoubleMultiply", "SoftAdditive", "LinearDodge" };        private List<string> matTypes = new List<string> { "PBR", "Unlit" };        private TextureSettings abedoTextureSetting = new TextureSettings() { compress = true, linearColor = false, wrapMode = TextureWrapMode.Clamp };        private TextureSettings maskTextureSetting = new TextureSettings() { compress = true, linearColor = false };        private TextureSettings emissionTextureSetting = new TextureSettings() { compress = true, linearColor = false };        private TextureSettings normalTextureSetting = new TextureSettings() { compress = false, linearColor = true, isNormalMap = true };        private TextureSettings metalTextureSetting = new TextureSettings() { compress = false, linearColor = true};        private TextureSettings occlusionTextureSetting = new TextureSettings() { compress = false, linearColor = true };        private JSONStorableColor mainColor;        private JSONStorableFloat mainAlpha;        private JSONStorableFloat glossiness;        private JSONStorableUrl abedoTextureUrl;        private JSONStorableUrl maskTextureUrl;        private JSONStorableUrl normalTextureUrl;        private JSONStorableFloat metallic;        private JSONStorableUrl metallicMapUrl;        private JSONStorableColor emissionColor;        private JSONStorableFloat cutoutRadio;        private JSONStorableFloat occlusion;        private JSONStorableFloat scaleX;        private JSONStorableFloat scaleY;        private JSONStorableFloat scaleZ;        private JSONStorableUrl metallicGlossMap;        private JSONStorableUrl emissionMapUrl;        private JSONStorableUrl occlusionMapUrl;        public JSONStorableAction nextImgAction;        public JSONStorableAction prevImgAction;        public int currentPlayMode = PlayMode.STATIC;        private JSONStorableBool isShowFrame;        private JSONStorableStringChooser blendModeChooser;        private JSONStorableStringChooser matTypeChooser;        private GameObject decalCube;        private DecalComp decalComp;        private TimerManager timerManager;        private Dictionary<string, Material> dic_BundleMaterials = new Dictionary<string, Material>();        private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();        private List<Texture2D> decalTextures;        private float abdeoHWRaido = 1;        private Material defaultMat;        private CameraHook cameraHook;        private Material mat;        public Material Mat        {            get            {                CreateMat();                return mat;            }        }        public Transform CenterCameraTrans        {            get            {                if (Utils.IsInVR())                {                    if (SuperController.singleton.isOpenVR)                    {                        return SuperController.singleton.ViveCenterCamera.transform;                    }                    return SuperController.singleton.OVRCenterCamera.transform;                }                else                {                    return SuperController.singleton.MonitorCenterCamera.transform;                }            }        }        private void CreateMat()        {            if (mat == null)            {                MeshRenderer meshRenderer = decalComp.MeshHolderTrans.GetComponent<MeshRenderer>();                meshRenderer.material = dic_BundleMaterials["DecalMat"];                defaultMat = new Material(meshRenderer.material);                mat = meshRenderer.material;            }            if (matTypeChooser.val == "PBR")            {                mat.shader = dic_BundleShaders["PluginIdea/StandardPbr"];            }            else            {                mat.shader = dic_BundleShaders["PluginIdea/UnlitDecal"];            }        }        private bool isExternalResourcesLoaded;        private bool IsExternalResourcesLoaded        {            get { return this.isExternalResourcesLoaded; }        }        public bool IsShowWire        {            set            {                decalComp.WireMeshHolderTrans.gameObject.SetActive(value);            }        }        public override void Init()        {            base.Init();            if (containingAtom.type != "Empty")            {                SuperController.LogError("need add on Empty Atom");                return;            }            timerManager = new TimerManager();            ResourceInit();            EventInit();            UIInit();            decalTextures = new List<Texture2D>() {                abedoTex, matallicTex, normalTex, occlusionTex, emssionTex            };        }        private void Start()        {            if (Utils.IsInVR())            {                cameraHook = Utils.GetSafeComponent<CameraHook>(CenterCameraTrans.gameObject);                cameraHook.onPostRenderCallback += OnPostRender;            }            else            {                if (GLRenderer.Instance == null)                {                    new GameObject                    {                        name = "GLRenderer"                    }.AddComponent<GLRenderer>();                }                GLRenderer.Instance.Add(this);            }        }                private void UIInit()        {            Utils.OnInitUI(CreateUIElement);            Utils.SetupInfoText(this, Location.GetStr(Location.PluginInfoMeshDecal), 800, true);            Utils.SetupSpacer(this, 40, false);            Utils.SetupButton(this, Location.GetStr(Location.ReGenerateDecal), () =>            {                SyncDecalSize();                decalComp.GetTargetObejcts();            }, false);                                    Utils.SetupSpacer(this, 20, true);            mainColor = Utils.SetupColor(this, Location.GetStr(Location.MainColor), Color.white, true);            mainColor.setCallbackFunction = (h, s, v) =>            {                if (!IsExternalResourcesLoaded) return;                Mat.SetColor("_Color", Color.HSVToRGB(h, s, v));            };            emissionColor = Utils.SetupColor(this, Location.GetStr(Location.EmissionColor), Color.black, true);            emissionColor.setCallbackFunction = (h, s, v) =>            {                if (!IsExternalResourcesLoaded) return;                Mat.SetColor("_EmissionColor", Color.HSVToRGB(h, s, v));            };                        Utils.SetupSpacer(this, 60, false);            scaleX = Utils.SetupSliderFloatWithRange(this, Location.GetStr(Location.ScaleWidth), 0.5f, 0.1f, 5f, false);            scaleX.setCallbackFunction = (val) =>            {                decalCube.transform.localScale = new Vector3(val, decalCube.transform.localScale.y, val * abdeoHWRaido);            };            scaleY = Utils.SetupSliderFloatWithRange(this, Location.GetStr(Location.ScaleHeight), 0.5f, 0.1f, 5f, false);            scaleY.setCallbackFunction = (val) =>            {                decalCube.transform.localScale = new Vector3(decalCube.transform.localScale.x, val, decalCube.transform.localScale.z);            };            matTypeChooser = Utils.SetupStringChooser(this, Location.GetStr(Location.MaterialType), matTypes, false);                        blendModeChooser = Utils.SetupStringChooser(this, Location.GetStr(Location.BlendMode), blendModes, false);            blendModeChooser.setCallbackFunction = (val) => {                if (!IsExternalResourcesLoaded) return;                cutoutRadio.val = 0.5f;                switch (val)                {                    case "Opaque":                        Mat.SetInt("_SrcBlend", BlendMode.One);                        Mat.SetInt("_DstBlend", BlendMode.Zero);                        break;                    case "AlphaBlend":                        Mat.SetInt("_SrcBlend", BlendMode.SrcAlpha);                        Mat.SetInt("_DstBlend", BlendMode.OneMinusSrcAlpha);                        cutoutRadio.val = 0;                        break;                    case "Multiply":                        Mat.SetInt("_SrcBlend", BlendMode.DstColor);                        Mat.SetInt("_DstBlend", BlendMode.Zero);                        break;                    case "DoubleMultiply":                        Mat.SetInt("_SrcBlend", BlendMode.DstColor);                        Mat.SetInt("_DstBlend", BlendMode.SrcColor);                        break;                    case "SoftAdditive":                        Mat.SetInt("_SrcBlend", BlendMode.DstColor);                        Mat.SetInt("_DstBlend", BlendMode.One);                        cutoutRadio.val = 0;                        break;                    case "LinearDodge":                        Mat.SetInt("_SrcBlend", BlendMode.One);                        Mat.SetInt("_DstBlend", BlendMode.One);                        break;                    default:                        break;                }            };            ParaMeterSet();        }        private Texture2D abedoTex, matallicTex, normalTex, occlusionTex, emssionTex, maskTex;        private void ParaMeterSet()        {                        isShowFrame = Utils.SetupToggle(this, Location.GetStr(Location.ShowGizmos), true, false);                        Utils.SetupToggle(this, Location.GetStr(Location.ShowWireMesh), false, false).setCallbackFunction = (val) =>            {                IsShowWire = val;            };                        Utils.SetupSpacer(this, 40, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.CommonParametersSubtitle), 45, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.AbedoSubtitle), 35, false);            abedoTextureUrl = Utils.SetupTexture2DChooser(this, Location.GetStr(Location.SetMainDecalTexure), $"Custom/Assets/MyAssets", false, abedoTextureSetting, (tex) =>            {                if (!IsExternalResourcesLoaded) return;                if (abedoTex != null) Destroy(abedoTex);                abedoTex = tex;                Mat.SetTexture("_MainTex", tex);                SyncDecalSize();            });            mainAlpha = Utils.SetupSliderFloatWithRange(this, Location.GetStr(Location.MainAlpha), 1, 0f, 1f, false);            mainAlpha.setCallbackFunction = (val) =>            {                if (!IsExternalResourcesLoaded) return;                Color color = Mat.GetColor("_Color");                color.a = val;                Mat.SetColor("_Color", color);            };                        cutoutRadio = Utils.SetupSliderFloat(this, Location.GetStr(Location.AlphaCutOff), 0.5f, 0f, 1f, false);            cutoutRadio.setCallbackFunction = (val) =>            {                if (!IsExternalResourcesLoaded) return;                Mat.SetFloat("_CutOff", val);            };            Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () => {                Destroy(Mat.GetTexture("_MainTex"));                abedoTextureUrl.Reload();            }, Location.GetStr(Location.Remove), () => {                Destroy(Mat.GetTexture("_MainTex"));                Mat.SetTexture("_MainTex", defaultMat.GetTexture("_MainTex"));            }, false);                        Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.MaskSubtitle), 35, false);            maskTextureUrl = Utils.SetupTexture2DChooser(this, Location.GetStr(Location.SetMaskTexure), $"Custom/Assets/MyAssets", false, maskTextureSetting, (tex) =>            {                if (!IsExternalResourcesLoaded) return;                if (maskTex != null) Destroy(maskTex);                maskTex = tex;                Mat.SetTexture("_MaskTex", maskTex);            });            Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () => {                Destroy(Mat.GetTexture("_MaskTex"));                maskTextureUrl.Reload();            }, Location.GetStr(Location.Remove), () => {                Destroy(Mat.GetTexture("_MaskTex"));                Mat.SetTexture("_MaskTex", defaultMat.GetTexture("_MaskTex"));            }, false);                        Utils.SetupSpacer(this, 20, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.EmissionSubtitle), 35, false);            emissionMapUrl = Utils.SetupTexture2DChooser(this, Location.GetStr(Location.SetMainEmissionTex), $"Custom/Assets/MyAssets", false, emissionTextureSetting, (tex) =>            {                if (!IsExternalResourcesLoaded) return;                if (emssionTex != null) Destroy(emssionTex);                emssionTex = tex;                Mat.SetTexture("_EmissionTex", tex);            });            Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () => {                Destroy(Mat.GetTexture("_EmissionTex"));                emissionMapUrl.Reload();            }, Location.GetStr(Location.Remove), () => {                Destroy(Mat.GetTexture("_EmissionTex"));                Mat.SetTexture("_EmissionTex", defaultMat.GetTexture("_EmissionTex"));            }, false);                        Utils.SetupSpacer(this, 50, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.PBRParametersSubtitle), 45, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.MetallicSubtitle), 35, false);                        metallicMapUrl = Utils.SetupTexture2DChooser(this, Location.GetStr(Location.SetMetallicMapTexture), $"Custom/Assets/MyAssets", false, metalTextureSetting, (tex) =>            {                if (!IsExternalResourcesLoaded) return;                if (matallicTex != null) Destroy(matallicTex);                matallicTex = tex;                Mat.SetTexture("_MetallicTex", tex);            });            var metallicTBtn = Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () => {                Destroy(Mat.GetTexture("_MetallicTex"));                metallicMapUrl.Reload();            }, Location.GetStr(Location.Remove), () => {                Destroy(Mat.GetTexture("_MetallicTex"));                Mat.SetTexture("_MetallicTex", defaultMat.GetTexture("_MetallicTex"));            }, false);            metallic = Utils.SetupSliderFloatWithRange(this, Location.GetStr(Location.Metallic), 0.5f, 0f, 1f, false);            metallic.setCallbackFunction = (val) =>            {                if (!IsExternalResourcesLoaded) return;                Mat.SetFloat("_Metallic", val);            };            glossiness = Utils.SetupSliderFloatWithRange(this, Location.GetStr(Location.Glossiness), 0.5f, 0f, 1f, false);            glossiness.setCallbackFunction = (val) =>            {                if (!IsExternalResourcesLoaded) return;                Mat.SetFloat("_Glossiness", val);            };                        Utils.SetupSpacer(this, 20, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.BumpMapSubtitle), 35, false);            normalTextureUrl = Utils.SetupTexture2DChooser(this, Location.GetStr(Location.SetMainBumpMapTexure), $"Custom/Assets/MyAssets", false, normalTextureSetting, (tex) =>            {                if (!IsExternalResourcesLoaded) return;                if (normalTex != null) Destroy(normalTex);                normalTex = tex;                Mat.SetTexture("_BumpMap", tex);            });            var bumpMapTBtn = Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () => {                Destroy(Mat.GetTexture("_BumpMap"));                normalTextureUrl.Reload();            }, Location.GetStr(Location.Remove), () => {                Destroy(Mat.GetTexture("_BumpMap"));                Mat.SetTexture("_BumpMap", defaultMat.GetTexture("_BumpMap"));            }, false);                                                                                                Utils.SetupSpacer(this, 20, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.OcclusionSubtitle), 35, false);            occlusionMapUrl = Utils.SetupTexture2DChooser(this, Location.GetStr(Location.SetMainOcclusionTexure), $"Custom/Assets/MyAssets", false, occlusionTextureSetting, (tex) =>            {                if (!IsExternalResourcesLoaded) return;                if (occlusionTex != null) Destroy(occlusionTex);                occlusionTex = tex;                Mat.SetTexture("_OcclusionTex", tex);            });            var occlusionTBtn = Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () => {                Destroy(Mat.GetTexture("_OcclusionTex"));                occlusionMapUrl.Reload();            }, Location.GetStr(Location.Remove), () => {                Destroy(Mat.GetTexture("_OcclusionTex"));                Mat.SetTexture("_OcclusionTex", defaultMat.GetTexture("_OcclusionTex"));            }, false);            occlusion = Utils.SetupSliderFloat(this, "Occlusion", 1f, 0.5f, 3f, false);            occlusion.setCallbackFunction = (val) =>            {                if (!IsExternalResourcesLoaded) return;                Mat.SetFloat("_Occlusion", val);            };                    }        private void ResourceInit()        {            OnCreateDecalObject();            string assetsBundlePath = Utils.GetPluginPath(this) + "/resources/meshdecal.assetbundle";            Request request = new Request { path = assetsBundlePath, callback = OnAssetBundleLoaded };            AssetLoader.QueueLoadAssetBundleFromFile(request);        }        private void OnAssetBundleLoaded(Request request)        {            Material[] materials = request.assetBundle.LoadAllAssets<Material>();            for (int i = 0; i < materials.Length; i++)            {                SuperController.LogMessage("Mat: " + materials[i].name);                if (!dic_BundleMaterials.ContainsKey(materials[i].name))                {                    dic_BundleMaterials.Add(materials[i].name, materials[i]);                }            }            Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();            for (int i = 0; i < shaders.Length; i++)            {                SuperController.LogMessage("Shader: " + shaders[i].name);                if (!dic_BundleShaders.ContainsKey(shaders[i].name))                {                    dic_BundleShaders.Add(shaders[i].name, shaders[i]);                }            }            ReloadParameters();        }        private void EventInit()        {            SuperController.singleton.onSceneLoadedHandlers += OnAfterSceneLoaded;        }                        private void OnAfterSceneLoaded()        {            timerManager.AddTimer(2f, () =>            {                ReloadParameters();            });        }        private void ReloadParameters()        {                                    isExternalResourcesLoaded = true;            abedoTextureUrl.Reload();            metallicMapUrl.Reload();            normalTextureUrl.Reload();            occlusionMapUrl.Reload();            emissionMapUrl.Reload();            maskTextureUrl.Reload();                        mainAlpha.setCallbackFunction(mainAlpha.val);            metallic.setCallbackFunction(metallic.val);            glossiness.setCallbackFunction(glossiness.val);            occlusion.setCallbackFunction(occlusion.val);            cutoutRadio.setCallbackFunction(cutoutRadio.val);            mainColor.setCallbackFunction(mainColor.val.H, mainColor.val.S, mainColor.val.V);            emissionColor.setCallbackFunction(emissionColor.val.H, emissionColor.val.S, emissionColor.val.V);            blendModeChooser.setCallbackFunction(blendModeChooser.val);                        decalComp.WireMeshHolderTrans.GetComponent<MeshRenderer>().material = dic_BundleMaterials["WireLine"];            decalComp.GetTargetObejcts();        }                private void Update()        {            timerManager.Update();        }        private void OnCreateDecalObject()        {            decalCube = null;            decalCube = GameObject.CreatePrimitive(PrimitiveType.Cube);            decalCube.GetComponent<Collider>().enabled = false;            decalCube.GetComponent<MeshRenderer>().enabled = false;            decalCube.transform.SetParent(containingAtom.reParentObject.Find("object/rescaleObject"));            decalCube.transform.localScale = new Vector3(0.5f, 0.5f, 0.5f);            decalCube.transform.localPosition = Vector3.zero;            decalCube.transform.localRotation = Quaternion.identity;            decalComp = Utils.GetSafeComponent<DecalComp>(decalCube);            decalComp.Init(this);        }        private void SyncDecalSize()        {            if (abedoTex == null) return;            abdeoHWRaido = (float)abedoTex.height / abedoTex.width;            decalCube.transform.localScale = new Vector3(decalCube.transform.localScale.x, decalCube.transform.localScale.x * abdeoHWRaido, decalCube.transform.localScale.z);        }        private Color gizmosUpColor = Color.gray;        private Color gizmosDownColor = Color.green;        private void OnPostRender()        {            if (decalCube != null && isShowFrame.val)            {                Transform decalTrans = decalCube.transform;                Vector3 u1 = decalTrans.TransformPoint(new Vector3(-0.5f, 0.5f, 0.5f));                Vector3 u2 = decalTrans.TransformPoint(new Vector3(0.5f, 0.5f, 0.5f));                Vector3 u3 = decalTrans.TransformPoint(new Vector3(0.5f, -0.5f, 0.5f));                Vector3 u4 = decalTrans.TransformPoint(new Vector3(-0.5f, -0.5f, 0.5f));                Vector3 d1 = decalTrans.TransformPoint(new Vector3(-0.5f, 0.5f, -0.5f));                Vector3 d2 = decalTrans.TransformPoint(new Vector3(0.5f, 0.5f, -0.5f));                Vector3 d3 = decalTrans.TransformPoint(new Vector3(0.5f, -0.5f, -0.5f));                Vector3 d4 = decalTrans.TransformPoint(new Vector3(-0.5f, -0.5f, -0.5f));                GLDrawHelper.DrawLine3D(new List<GLLine3D> {                    new GLLine3D(){ from = u1, to = u2, color = gizmosUpColor},                    new GLLine3D(){ from = u2, to = u3, color = gizmosUpColor},                    new GLLine3D(){ from = u3, to = u4, color = gizmosUpColor},                    new GLLine3D(){ from = u4, to = u1, color = gizmosUpColor},                }, null);                GLDrawHelper.DrawLine3D(new List<GLLine3D> {                    new GLLine3D(){ from = d1, to = d2, color = gizmosDownColor},                    new GLLine3D(){ from = d2, to = d3, color = gizmosDownColor},                    new GLLine3D(){ from = d3, to = d4, color = gizmosDownColor},                    new GLLine3D(){ from = d4, to = d1, color = gizmosDownColor},                }, null);                GLDrawHelper.DrawLine3D(new List<GLLine3D> {                    new GLLine3D(){ from = u1, to = d1, color = Color.white},                    new GLLine3D(){ from = u2, to = d2, color = Color.white},                    new GLLine3D(){ from = u3, to = d3, color = Color.white},                    new GLLine3D(){ from = u4, to = d4, color = Color.white},                }, null);                GizmosHelper.DrawArrow3D(decalTrans, decalCube.transform.localScale.z * 0.4f, Color.green);            }        }        private void OnDestroy()        {            if (decalCube != null)            {                Destroy(decalCube);            }            timerManager = null;            if (Utils.IsInVR())            {                Destroy(cameraHook);            }            else            {                GLRenderer.Instance.Remove(this);            }            SuperController.singleton.onSceneLoadedHandlers -= OnAfterSceneLoaded;                        decalTextures.ForEach(tex => {                if (tex != null)                {                    Destroy(tex);                }            });            decalTextures.Clear();            Utils.OnDestroyUI();        }        public void Draw(int cullingMask)        {            OnPostRender();        }    }}