/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using UnityEngine.Video;using UnityEngine.UI;using System.Linq;using System;namespace PluginIdea{    public class VideoPlayerModule    {        public Action<Texture> onVideoTextureSettedCallback;        private MVRScript ower;        private JSONStorableBool isLoop;        private FloatTrigger realTimeAudioAmpTrigger;        private JSONStorableFloat audioVolume;        private JSONStorableFloat audioMinDistance;        private JSONStorableFloat audioMaxDistance;        private JSONStorableFloat playProgress;        private JSONStorableUrl videoUrl;        private JSONStorableBool isPlay;        private JSONStorableBool isUpdateAudioResponse;        private VideoPlayer videoPlayer;        private AudioSource audioSource;        private float[] smaples = new float[128];        public VideoPlayerModule(MVRScript ower)        {            this.ower = ower;        }        public void Init()        {            Utils.SetupInfoTextNoScroll(this.ower, Location.GetStr(Location.VideoPlaySubtitle), 35, true);            videoUrl = Utils.SetupVideoChooser(ower, Location.GetStr(Location.ChooseVideoFile), $"Custom/Assets/", true, LoadVideoClip);            playProgress = Utils.SetupSliderFloat(ower, Location.GetStr(Location.PlayProgress), 0f, 0f, 1f, true);            playProgress.setCallbackFunction = SetProgress;            Utils.SetupButton(ower, Location.GetStr(Location.PlayStop), OnPlayStopClick, true);            isLoop = Utils.SetupToggle(ower, Location.GetStr(Location.IsLoop), true, true);            isLoop.setCallbackFunction = (val => {                videoPlayer.isLooping = val;            });            audioVolume = Utils.SetupSliderFloat(ower, Location.GetStr(Location.AudioVolume), 1f, 0f, 1f, true);            audioVolume.setCallbackFunction = (val) => { audioSource.volume = val; };            isUpdateAudioResponse = Utils.SetupToggle(ower, Location.GetStr(Location.IsUpdateAudioResponse), false, true);            realTimeAudioAmpTrigger = new FloatTrigger(ower, "AudioAmpTrigger");            Utils.SetupButton(ower, Location.GetStr(Location.SetAudioAction), realTimeAudioAmpTrigger.OpenPanel, true);            audioMinDistance = Utils.SetupSliderFloat(ower, Location.GetStr(Location.AudioMinDistance), 1f, 0f, 1000f, true);            audioMinDistance.setCallbackFunction = (val) => { audioSource.minDistance = val; };            audioMaxDistance = Utils.SetupSliderFloat(ower, Location.GetStr(Location.AudioMaxDistance), 500f, 0f, 1000f, true);            audioMaxDistance.setCallbackFunction = (val) => { audioSource.maxDistance = val; };            isPlay = new JSONStorableBool("Is Play", true);            ower.RegisterBool(isPlay);                        AddVideoComponents();        }        public void DelayInit()        {            videoUrl.Reload();        }        public void AddVideoComponents()        {            videoPlayer = Utils.GetSafeComponent<VideoPlayer>(ower.gameObject);            audioSource = Utils.GetSafeComponent<AudioSource>(ower.gameObject);            videoPlayer.playOnAwake = false;            audioSource.playOnAwake = false;            videoPlayer.source = VideoSource.Url;            videoPlayer.renderMode = VideoRenderMode.APIOnly;            videoPlayer.audioOutputMode = VideoAudioOutputMode.AudioSource;            videoPlayer.controlledAudioTrackCount = 1;            videoPlayer.EnableAudioTrack(0, true);            videoPlayer.SetTargetAudioSource(0, audioSource);            videoPlayer.isLooping = isLoop.val;            videoPlayer.prepareCompleted += OnVideoPlayerPrepared;            audioSource.volume = audioVolume.val;                                                audioSource.minDistance = audioMinDistance.val;            audioSource.maxDistance = audioMaxDistance.val;        }        private void LoadVideoClip(string path)        {            if (string.IsNullOrEmpty(path) || !isPlay.val) return;            videoPlayer.Stop();            SuperController.LogMessage(Application.dataPath);            if (!path.StartsWith("http:"))            {                string realpath = Utils.GetGameRootDir() + "/" + path;                videoPlayer.url = realpath;            }                        videoPlayer.Play();        }        private void OnVideoPlayerPrepared(VideoPlayer source)        {            if (onVideoTextureSettedCallback != null) onVideoTextureSettedCallback(source.texture);        }        private void SetProgress(float progress)        {            if (videoPlayer != null && videoPlayer.isPrepared)            {                long targetFrame = (long)(videoPlayer.frameCount * progress);                videoPlayer.frame = targetFrame;            }        }        public void OnUpdate()        {            if (videoPlayer.isPlaying && isUpdateAudioResponse.val)            {                audioSource.GetSpectrumData(smaples, 0, FFTWindow.Rectangular);                float sum = 0;                for (int i = 0; i < smaples.Length; i++)                {                    sum += smaples[i];                }                float avg = sum /= smaples.Length;                realTimeAudioAmpTrigger.Trigger(avg * 30);            }        }        private void OnPlayStopClick()        {            if (isPlay.val)            {                isPlay.val = false;                videoPlayer.Stop();            }            else            {                isPlay.val = true;                videoPlayer.Play();            }        }        public void UnInit()        {            GameObject.Destroy(videoPlayer);            GameObject.Destroy(audioSource);        }    }}